
var context2;
var usingDelim=false;
var ofile;
var inp;
var inpStr;
var fs = require('fs');   
var analysisType="Model";
var l1,i;
var start1,end1;
var postModels=[];
var plotArray1=[],plotArray=[],postTreeArray=[],postProbArray=[];

$('#outputFile').change(function () {
    ofile=$('#outputFile').val();
    plotPosterior(ofile);});

function plotPosterior(outFileName)
{
var canvas = document.getElementById('canvas2');
context2 = canvas.getContext('2d');
context2.textAlign = 'center';
try{
inp=fs.readFileSync(outFileName, 'utf-8'); 
if(inp.match("List of best models")) 
    { usingDelim=true; analysisType="Model" }
else
    { 
      if(inp.match("Best trees in the sample")) 
      { usingDelim=false; analysisType="Species Tree"; }
      else{ throw new Error("unrecognized output file format!"); }
    }
postModels=[];
plotArray1=[];
plotArray=[];
postTreeArray=[];
postProbArray=[];
inpStr=inp.split("\n");
l1=inpStr.length;
 
i=0;
 while(i<l1)
    {
            if(inpStr[i].search(/\(A\)/)!=-1)
                {
                    if(usingDelim) {start1=i+2;}
                    else {start1=i+1;}
                }
            if(inpStr[i].search(/\(B\)/)!=-1)
                {
                    end1=i-1;
                    break;
                }
            else
                {
                    i++;
                }
    }

        for(i=0;i<(end1-start1);i++)
        {
            var postObj={};
            postObj.counts=inpStr[i+start1].trim().split(/\s/)[0];
            postObj.postProb=inpStr[i+start1].trim().split(/\s/)[2];
            plotArray1.push([String(i+1),Number(postObj.counts)]);
            postProbArray.push(postObj.postProb);
            if(usingDelim)
            {
             var n1=inpStr[i+start1].indexOf(")");
             var n2=inpStr[i+start1].indexOf(";");
             postObj.tree=inpStr[i+start1].substring(n1+1,n2+1).trim();
            }
            else
            {
             var n1=inpStr[i+start1].indexOf("(");
             var n2=inpStr[i+start1].indexOf(";");
             postObj.tree=inpStr[i+start1].substring(n1,n2+1).trim();            
            }
            postTreeArray.push(postObj.tree);
            postModels.push(postObj);  
        }

if(plotArray1.length>50)
{ plotArray1.length=50; }
plotArray.push(plotArray1);

var options = {
    series: {
        lines: { show: true },
        points: { show: true }
    }
};
  
    
var plot = $.plot($("#chart"), plotArray, 
        {
			series: {
				bars: {
					show: true,
					barWidth: 0.6,
					align: "center"
				}
			},
    grid: {
				hoverable: true,
				clickable: true
			},

			xaxis: {
				mode: "categories",
				tickLength: 0
			}
		}); 

var o = plot.pointOffset({ x: 0, y: 0});

$("#chart").append("<div class=\"treeLabel\" style='position:absolute;left:" + (o.left + 200) + "px;top:" + (o.top -220)  + "px;color:#E67840;font-size:small'>" + analysisType + " 1 Posterior Probability: " + postProbArray[0] +"</div>");
$("#chart").append("<div style='position:absolute;left:" + (o.left + 200) + "px;top:" + (o.top -200)  + "px;color:#808080;font-size:small'>Click on Bar to View " + analysisType + "</div>");
context2.clearRect ( 0 , 0 , canvas.width, canvas.height );
drawOneTree(0,postTreeArray,true,context2,true,100);
    
    
$("#chart").bind("plotclick", function (event, pos, item) {
			if (item) {
                $(".treeLabel").remove();
                $("#chart").append("<div class=\"treeLabel\" style='position:absolute;left:" + (o.left + 200) + "px;top:" + (o.top -220)  + "px;color:#E67840;font-size:small'>" + analysisType + " " + (item.dataIndex+1) + " Posterior Probability: " + postProbArray[item.dataIndex] + "</div>");
				$("#clickdata").text(" - click point " + item.dataIndex + " in " + item.series.label);
                context2.clearRect ( 0 , 0 , canvas.width, canvas.height );
                drawOneTree(item.dataIndex,postTreeArray,true,context2,true,100);
                }});

 
}
catch(err){ alert(err); }
};
